<template>
<div>
  <b-dropdown id="dropdown-grouped" text="Go to Projects" variant="primary" class="m-2" dropleft>
    <b-form-input id="myInput" v-model="search" type="search" class="m-2" placeholder="Project Name"></b-form-input>
    <b-dropdown-divider></b-dropdown-divider>
        <div v-for="(project, index) in filteredList" :key="project.id">
            <dropdown-component :projectName="project.name" :class="{ 'active': index === 0 }"></dropdown-component>
                <div v-for="group in project.groups" :key="group.id">
                    <b-dropdown-item-button id="dropdown-item">
                      <span  v-html="$options.filters.highlight(group.name, search)">{{group.name}}</span>
                    </b-dropdown-item-button>
                </div>
        </div>
  </b-dropdown>
</div>
</template>

<script>
// @ is an alias to /src

import DropdownComponent from './DropdownComponent.vue';

export default {
  components: {
    'dropdown-component': DropdownComponent
  },
  mounted() {
    this.fetchData();
    this.getCategories();
    this.getProjects();
  },
  prop:
    [],
  data() {
    return {
      jsonData: [],
      categories: [],
      projects: [],
      search: ""
    }
  },
    methods: {
        //add try catch block
        async fetchData() {
          try {
            const res = await fetch('http://localhost:3000/projects');
            const val = await res.json();
            this.jsonData = val;
          } catch (e) {
            console.log(e);
          }

        },
        getCategories() {
            var arr = [];
            for (let index = 0; index < this.jsonData.length; index++) {
                const element = this.jsonData[index].name;
                arr.push(element)
            }
            this.categories = arr;
        },
        getProjects() {
            var arr = [];
            for (let index = 0; index < this.jsonData.length; index++) {
                for (let j = 0; j < this.jsonData[index].groups.length; j++) {
                    const element = this.jsonData[index].groups[j].name;
                    arr.push(element)
                }
            }
            this.projects = arr;
        },

    },
  computed: {
    filteredList() {
      var t = this;
      if (!t.search.toLowerCase().trim()) {
        return this.jsonData;
      }
      else {
        return this.jsonData
        .map(item => {
          return {
            ...item,
            groups: item.groups.filter(project => {
              return project.name.toLowerCase().includes(t.search.toLowerCase().trim());
            })
          }
        })
        .filter((val) => val.groups.length !== 0);
      }
    }
  },
  filters: {
    highlight: (word, query) => {
      var check = new RegExp(query, "ig");
      return word.toString().replace(check, function(matchedText) {
        return ('<strong style="background-color: yellow">' + matchedText + '</strong>');
      })
    }
  }
    }
</script>

<style lang="scss" scoped>
  .active{
    background-color: azure;
  }
</style>